//import com.cyberbotics.webots.Controller;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.geom.*;
import java.lang.*;
import java.awt.event.*;
import java.text.*;
import java.util.*;

public class ALife1 extends MyBot
{
}

class Gui extends JFrame
{
  JProgressBar m_bateryBar;
  JLabel m_translation, m_rotation, m_x, m_y, m_a, m_ids, m_ida;
  MapGui m_map;

  public Gui() // {{{
  {
    super("MyBot: main window");
    try 
    {
      UIManager.setLookAndFeel(
      UIManager.getCrossPlatformLookAndFeelClassName());
    } catch (Exception e) { }
    
    Container root = getContentPane();
    root.setLayout(new BoxLayout(root, BoxLayout.X_AXIS));
    Box box = new Box(BoxLayout.Y_AXIS);
    box.add(createCamerasGui());
    box.add(m_map = new MapGui());
    box.add(createRelPositionGui());
    box.add(createRotSpeedSlider());
    box.add(createBateryMonitorGui());
    root.add(box);
    root.add(createSpeedSlider());
    pack();
    //setLocation(0,0);
    setVisible(true);
  } // }}}
  Container createSpeedSlider() // {{{
  {
    JSlider slider = new JSlider(JSlider.VERTICAL, -20, 20, 0);
    slider.setMajorTickSpacing(5);
    slider.setMinorTickSpacing(1);
    slider.setPaintTicks(true);
    slider.setPaintLabels(true);
    slider.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
    slider.setSnapToTicks(true);
    slider.addChangeListener(new SpeedListener());
    return slider;
  } 
  class SpeedListener implements ChangeListener 
  {
    public void stateChanged(ChangeEvent e) 
    {
      MyBot.setSpeed((int)((JSlider)e.getSource()).getValue());
    }
  }// }}}
  Container createRotSpeedSlider() // {{{
  {
    JSlider slider = new JSlider(JSlider.HORIZONTAL, -20, 20, 0);
    slider.setMajorTickSpacing(5);
    slider.setMinorTickSpacing(1);
    slider.setPaintTicks(true);
    slider.setPaintLabels(true);
    TitledBorder border = BorderFactory.createTitledBorder("Rotational Speed");
    border.setTitleJustification(TitledBorder.CENTER);
    slider.setBorder(border);
    slider.setSnapToTicks(true);
    slider.addChangeListener(new RotSpeedListener());
    return slider;
  } 
  class RotSpeedListener implements ChangeListener 
  {
    public void stateChanged(ChangeEvent e) 
    {
      MyBot.setRotSpeed((int)((JSlider)e.getSource()).getValue());
    }
  }// }}}

  Container createCamerasGui() // {{{
  {
    Box cameras = new Box(BoxLayout.X_AXIS);

    JPanel filterPanel = new JPanel();
    filterPanel.setBorder(BorderFactory.createCompoundBorder(
                      BorderFactory.createTitledBorder("Camera"),
                      BorderFactory.createEmptyBorder(5,5,5,5)));
    filterPanel.add(new JLabel(new ImageIcon(createImage(MyBot.m_imgSource))));
    cameras.add(filterPanel);

    filterPanel = new JPanel();
    filterPanel.setBorder(BorderFactory.createCompoundBorder(
                      BorderFactory.createTitledBorder("Green Filter"),
                      BorderFactory.createEmptyBorder(5,5,5,5)));
    filterPanel.add(new JLabel(new ImageIcon(createImage(
              new FilteredImageSource(MyBot.m_imgSource, new GreenFilter())
              ))));
    cameras.add(filterPanel);
    
    filterPanel = new JPanel();
    filterPanel.setBorder(BorderFactory.createCompoundBorder(
                      BorderFactory.createTitledBorder("General Filter"),
                      BorderFactory.createEmptyBorder(5,5,5,5)));
    filterPanel.add(new JLabel(new ImageIcon(createImage(
              new FilteredImageSource(MyBot.m_imgSource, new GeneralFilter())
              ))));
    cameras.add(filterPanel);

    return cameras;
  } // }}}
  Container createRelPositionGui() // {{{
  {
    JPanel panel = new JPanel(new GridLayout(4,4,5,5));
    panel.add(new JLabel("Translation: ",JLabel.RIGHT));
    panel.add(m_translation = new JLabel());
    panel.add(new JLabel("X:", JLabel.RIGHT));
    panel.add(m_x = new JLabel());
    
    panel.add(new JLabel("Rotation: ",JLabel.RIGHT));
    panel.add(m_rotation = new JLabel());
    panel.add(new JLabel("Y:",JLabel.RIGHT));
    panel.add(m_y = new JLabel());
    
    panel.add(new JLabel("Inc dist:", JLabel.RIGHT));
    panel.add(m_ids = new JLabel());
    panel.add(new JLabel("Orientation:",JLabel.RIGHT));
    panel.add(m_a = new JLabel());
    
    panel.add(new JLabel("Inc orient:", JLabel.RIGHT));
    panel.add(m_ida = new JLabel());
    panel.add(new JLabel());
    panel.add(new JLabel());

    TitledBorder border = BorderFactory.createTitledBorder("Position Data");
    border.setTitleJustification(TitledBorder.CENTER);
    panel.setBorder(border);

    return panel;
  } // }}}
  Container createBateryMonitorGui  () // {{{
  {
    m_bateryBar = new JProgressBar(0, 100);
    m_bateryBar.setValue(0);
    TitledBorder border = BorderFactory.createTitledBorder("Batery Monitor");
    border.setTitleJustification(TitledBorder.CENTER);
    m_bateryBar.setBorder(border);
    m_bateryBar.setStringPainted(true);
    return m_bateryBar;
  } // }}}
  class MapGui extends JPanel// {{{
  {
    Graphics2D m_g;
    GeneralPath m_arrow;
    MapGui() // {{{
    { 
	    TitledBorder border = BorderFactory.createTitledBorder("Map");
	    border.setTitleJustification(TitledBorder.CENTER);
	    setBorder(border);
      BufferedImage img = new BufferedImage(
                Map.MAX_COORD/5*2, 
                Map.MAX_COORD/5*2,
                BufferedImage.TYPE_INT_RGB);
      JLabel l = new JLabel(new ImageIcon(img));
      l.setBorder(new LineBorder(Color.blue));
	    add(l);
      m_g = img.createGraphics();
      m_g.setBackground(getBackground());
      m_g.translate(Map.MAX_COORD/5,Map.MAX_COORD/5);
      m_g.scale(0.2,-0.2);
      m_g.setColor(getBackground());
      m_g.fill(new Rectangle(-Map.MAX_COORD,-Map.MAX_COORD,Map.MAX_COORD*2, Map.MAX_COORD*2));
      m_arrow = new GeneralPath();
      m_arrow.moveTo(0,0);
      m_arrow.lineTo(40,0);
      m_arrow.lineTo(30,10);
      m_arrow.moveTo(40,0);
      m_arrow.lineTo(30,-10);
    } // }}}
    void update()
    {
      m_g.setColor(getBackground());
      m_g.fill(new Rectangle(-Map.MAX_COORD,-Map.MAX_COORD,Map.MAX_COORD*2, Map.MAX_COORD*2));
      Rectangle2D.Float rect = new Rectangle2D.Float(-10.0f, -10.0f, 20.0f, 20.0f);
      AffineTransform tr = m_g.getTransform();
      
      m_g.translate(MyBot.m_x, MyBot.m_y);
      m_g.rotate(MyBot.m_a);
      m_g.setColor(Color.black);
      m_g.fill(rect);
      m_g.draw(m_arrow);
      
      m_g.setTransform(tr);
      repaint();
    }
  } // }}}
  public void update() // {{{
  {
    m_bateryBar.setValue(Math.round(MyBot.robot_battery_sensor_get_value()));
    NumberFormat f = NumberFormat.getNumberInstance();
    f.setMaximumFractionDigits(6);
    m_translation.setText(f.format(MyBot.m_ds));
    m_rotation.setText(f.format(MyBot.m_da));
    m_x.setText(f.format(MyBot.m_x));
    m_y.setText(f.format(MyBot.m_y));
    m_a.setText(f.format(MyBot.m_a));
    m_ids.setText(f.format(MyBot.m_ids));
    m_ida.setText(f.format(MyBot.m_ida));
    m_map.update();
  } // }}}
}
// pocitani aktualni pozice z enkoderu
